
/****************************************************************************/
/*      TMKLL4P v4.29 for DPMI (DOS4G) for Watcom C. ELCUS, 1998,2006.      */
/*      Interface to the driver TMKLL4P v4.29 for DPMI (DOS4G).             */
/****************************************************************************/

#ifndef _TMKLLX_
#define _TMKLLX_

#define MAX_TMK_TYPE 5

#define RTMK 0
#define RTMK1 1
#define TMK400 2
#define TMKMPC 3
#define RTMK400 4
#define TMKX 5

#define ALL_TMKS 0x00FF

#define DATA_BC_RT 0x00
#define DATA_BC_RT_BRCST 0x08
#define DATA_RT_BC 0x01
#define DATA_RT_RT 0x02
#define DATA_RT_RT_BRCST 0x0A
#define CTRL_C_A 0x03
#define CTRL_C_BRCST 0x0B
#define CTRL_CD_A 0x04
#define CTRL_CD_BRCST 0x0C
#define CTRL_C_AD 0x05

#define BUS_A 0
#define BUS_B 1
#define BUS_1 0
#define BUS_2 1

#define ERAO_MASK 0x01
#define MEO_MASK 0x02
#define IB_MASK 0x04
#define TO_MASK 0x08
#define EM_MASK 0x10
#define EBC_MASK 0x20
#define DI_MASK 0x40
#define ELN_MASK 0x80
#define G1_MASK 0x1000
#define G2_MASK 0x2000

#define NWORDS_MASK 0x001F
#define CMD_MASK 0x001F
#define SUBADDR_MASK 0x03E0
#define CI_MASK 0x03E0
#define HBIT_MASK 0x0200
#define RT_DIR_MASK 0x0400
#define ADDRESS_MASK 0xF800
#define RTFL_MASK 0x0001
#define DNBA_MASK 0x0002
#define SSFL_MASK 0x0004
#define BUSY_MASK 0x0008
#define BRCST_MASK 0x0010
#define NULL_MASK 0x00E0
#define SREQ_MASK 0x0100
#define ERROR_MASK 0x0400

#define SREQ 0x01
#define BUSY 0x02
#define SSFL 0x04
#define RTFL 0x08
#define DNBA 0x10

#define CWB0 0x20
#define CWB1 0x40

#define BC_MODE 0x00
#define RT_MODE 0x80
#define MT_MODE 0x100
#define UNDEFINED_MODE 0xFFFF

#define RT_TRANSMIT 0x0400
#define RT_RECEIVE 0x0000

#define RT_ERROR_MASK 0x4000

#define RT_FLAG 0x8000
#define RT_FLAG_MASK 0x8000

#define RT_HBIT_MODE 0x0001
#define RT_FLAG_MODE 0x0002
#define RT_BRCST_MODE 0x0004
#define RT_DATA_BL 0x2000
#define RT_GENER1_BL 0x0004
#define RT_GENER2_BL 0x4000
#define BC_GENER1_BL 0x0004
#define BC_GENER2_BL 0x4000
#define MT_GENER1_BL 0x0004
#define MT_GENER2_BL 0x4000
#define TMK_IRQ_OFF 0x8000

#define CX_CC_MASK 0x000F
#define CX_CONT_MASK 0x0010
#define CX_BUS_MASK 0x0020
#define CX_SIG_MASK 0x8000
#define CX_INT_MASK 0x0020

#define CX_CONT 0x0010
#define CX_STOP 0x0000
#define CX_BUS_0 0x0000
#define CX_BUS_A 0x0000
#define CX_BUS_1 0x0020
#define CX_BUS_B 0x0020
#define CX_NOSIG 0x0000
#define CX_SIG 0x8000
#define CX_INT 0x0000
#define CX_NOINT 0x0020

#define SX_NOERR 0
#define SX_MEO 1
#define SX_TOA 2
#define SX_TOD 3
#define SX_ELN 4
#define SX_ERAO 5
#define SX_ESYN 6
#define SX_EBC 7

#define SX_ERR_MASK 0x0007
#define SX_IB_MASK 0x0008
#define SX_G1_MASK 0x0010
#define SX_G2_MASK 0x0020
#define SX_K2_MASK 0x0100
#define SX_K1_MASK 0x0200
#define SX_SCC_MASK 0x3C00
#define SX_ME_MASK 0x4000
#define SX_BUS_MASK 0x8000

#define SX_BUS_0 0x0000
#define SX_BUS_A 0x0000
#define SX_BUS_1 0x8000
#define SX_BUS_B 0x8000

#define GET_IO_DELAY 0xFFFF

#define CW(ADDR,DIR,SUBADDR,NWORDS) ((ADDR<<11)|DIR|(SUBADDR<<5)|(NWORDS&0x1F))
#define CWM(ADDR,COMMAND) ((ADDR<<11)|CI_MASK|COMMAND)

/*#define CMD_ILLEGAL 0x000*/
#define CMD_DYNAMIC_BUS_CONTROL 0x400
#define CMD_SYNCHRONIZE 0x401
#define CMD_TRANSMIT_STATUS_WORD 0x402
#define CMD_INITIATE_SELF_TEST 0x403
#define CMD_TRANSMITTER_SHUTDOWN 0x404
#define CMD_OVERRIDE_TRANSMITTER_SHUTDOWN 0x405
#define CMD_INHIBIT_TERMINAL_FLAG_BIT 0x406
#define CMD_OVERRIDE_INHIBIT_TERMINAL_FLAG_BIT 0x407
#define CMD_RESET_REMOTE_TERMINAL 0x408
#define CMD_TRANSMIT_VECTOR_WORD 0x410
#define CMD_SYNCHRONIZE_WITH_DATA_WORD 0x011
#define CMD_TRANSMIT_LAST_COMMAND_WORD 0x412
#define CMD_TRANSMIT_BUILT_IN_TEST_WORD 0x413

#define TMK_BAD_TYPE 1
#define TMK_BAD_IRQ 2
#define TMK_BAD_NUMBER 3
#define BC_BAD_BUS 4
#define BC_BAD_BASE 5
#define BC_BAD_LEN 6
#define RT_BAD_PAGE 7
#define RT_BAD_LEN 8
#define RT_BAD_ADDRESS 9
#define RT_BAD_FUNC 10
#define BC_BAD_FUNC 11
#define TMK_BAD_FUNC 12
#define TMK_DPMI_ERROR 100

#ifndef WORD
#define WORD unsigned short
#endif

#ifndef DWORD
#define DWORD unsigned long
#endif

#pragma aux TMKLL "_*" \
                   parm caller [] \
                   modify [eax];

#ifdef __cplusplus
extern "C" {
#endif

extern int tmkError;

extern void tmkOpenDPMI();
extern WORD tmkiodelay( WORD IODelay );
extern int tmkgetmaxn();
extern int tmkconfig( int tmkNumber, WORD tmkType, WORD tmkPorts1, WORD tmkPorts2, char tmkIrq1, char tmkIrq2 );
extern int tmkdone( int tmkNumber );
extern void tmkdeferrors( void __cdecl (* UserErrors)() );
extern int tmkselect( int tmkNumber );
extern int tmkselected();
extern WORD tmkgetmode();
extern void tmksave();
extern void tmkrestore();
extern void tmksetcwbits( WORD tmkSetControl );
extern void tmkclrcwbits( WORD tmkClrControl );
extern WORD tmkgetcwbits();

extern void bcdefintnorm( void __cdecl (* UserNormBC)( WORD, WORD, WORD ) );
extern void bcdefintexc( void __cdecl (* UserExcBC)( WORD, WORD, WORD ) );
extern void bcdefintx( void __cdecl (* UserXBC)( WORD, WORD ) );
extern void bcdefintsig( void __cdecl (* UserSigBC)( WORD ) );
extern int bcreset();
extern void bcrestore();
extern void bc_def_tldw( WORD wTLDW );
extern void bc_enable_di();
extern void bc_disable_di();
extern int bcdefirqmode( WORD bcIrqMode );
extern WORD bcgetirqmode();
extern WORD bcgetmaxbase();
extern int bcdefbase( WORD bcBasePC );
extern WORD bcgetbase();
extern void bcputw( WORD bcAddr, WORD bcData );
extern WORD bcgetw( WORD bcAddr );
extern DWORD bcgetansw( WORD bcCtrlCode );
extern void bcputblk( WORD bcAddr, void *pcBuffer, WORD cwLength );
extern void bcgetblk( WORD bcAddr, void *pcBuffer, WORD cwLength );
extern int bcdefbus( WORD bcBus );
extern WORD bcgetbus();
extern int bcstart( WORD bcBase, WORD bcCtrlCode );
extern int bcstartx( WORD bcBase, WORD bcCtrlCode );
extern int bcdeflink( WORD bcBase, WORD bcCtrlCode );
extern DWORD bcgetlink();
extern int bcstop();
extern DWORD bcgetstate();

extern void rtdefintcmd( void __cdecl (* UserCmdRT)( WORD ) );
extern void rtdefinterr( void __cdecl (* UserErrRT)( WORD ) );
extern void rtdefintdata( void __cdecl (* UserDataRT)( WORD ) );
extern int rtreset();
extern void rtrestore();
extern int rtdefirqmode( WORD rtIrqMode );
extern WORD rtgetirqmode();
extern int rtdefmode( WORD rtMode );
extern WORD rtgetmode();
extern WORD rtgetmaxpage();
extern int rtdefpage( WORD rtPage );
extern WORD rtgetpage();
extern int rtdefpagepc( WORD rtPagePC );
extern int rtdefpagebus( WORD rtPageBus );
extern WORD rtgetpagepc();
extern WORD rtgetpagebus();
extern int rtdefaddress( WORD rtAddress );
extern WORD rtgetaddress();
extern void rtdefsubaddr( WORD rtDir, WORD rtSubAddr);
extern WORD rtgetsubaddr();
extern void rtputw( WORD rtAddr, WORD rtData );
extern WORD rtgetw( WORD rtAddr );
extern void rtputblk( WORD rtAddr, void *pcBuffer, WORD cwLength );
extern void rtgetblk( WORD rtAddr, void *pcBuffer, WORD cwLength );
extern void rtsetanswbits( WORD rtSetControl );
extern void rtclranswbits( WORD rtClrControl );
extern WORD rtgetanswbits();
extern void rtgetflags( void *pcBuffer, WORD rtDir, WORD rtFlagMin, WORD rtFlagMax );
extern void rtputflags( void *pcBuffer, WORD rtDir, WORD rtFlagMin, WORD rtFlagMax );
extern void rtsetflag();
extern void rtclrflag();
extern WORD rtgetflag( WORD rtDir, WORD rtSubAddr );
extern WORD rtgetstate();
extern WORD rtbusy();
extern void rtlock( WORD rtDir, WORD rtSubAddr );
extern void rtunlock();
extern WORD rtgetcmddata( WORD rtBusCommand );
extern void rtputcmddata( WORD rtBusCommand, WORD rtData );

extern void mtdefintx( void __cdecl (* UserIntXMT)( WORD, WORD ) );
extern void mtdefintsig( void __cdecl (* UserSigMT)( WORD ) );
extern int mtreset();
#define mtrestore bcrestore
#define mtdefirqmode bcdefirqmode
#define mtgetirqmode bcgetirqmode
#define mtgetmaxbase bcgetmaxbase
#define mtdefbase bcdefbase
#define mtgetbase bcgetbase
#define mtputw bcputw
#define mtgetw bcgetw
extern WORD mtgetsw();
#define mtputblk bcputblk
#define mtgetblk bcgetblk
#define mtstartx bcstartx
#define mtdeflink bcdeflink
#define mtgetlink bcgetlink
#define mtstop bcstop
#define mtgetstate bcgetstate

#ifdef __cplusplus
}
#endif


#pragma aux (TMKLL) tmkOpenDPMI;

#pragma aux (TMKLL) tmkiodelay;
#pragma aux (TMKLL) tmkgetmaxn;
#pragma aux (TMKLL) tmkconfig;
#pragma aux (TMKLL) tmkdone;
#pragma aux (TMKLL) tmkdefirq;
#pragma aux (TMKLL) tmkundefirq;
#pragma aux (TMKLL) tmkdeferrors;
#pragma aux (TMKLL) tmkselect;
#pragma aux (TMKLL) tmkselected;
#pragma aux (TMKLL) tmkgetmode;
#pragma aux (TMKLL) tmksave;
#pragma aux (TMKLL) tmkrestore;
#pragma aux (TMKLL) tmksetcwbits;
#pragma aux (TMKLL) tmkclrcwbits;
#pragma aux (TMKLL) tmkgetcwbits;

#pragma aux (TMKLL) bcdefintnorm;
#pragma aux (TMKLL) bcdefintexc;
#pragma aux (TMKLL) bcdefintx;
#pragma aux (TMKLL) bcdefintsig;
#pragma aux (TMKLL) bcreset;
#pragma aux (TMKLL) bcrestore;
#pragma aux (TMKLL) bc_def_tldw;
#pragma aux (TMKLL) bc_enable_di;
#pragma aux (TMKLL) bc_disable_di;
#pragma aux (TMKLL) bcdefirqmode;
#pragma aux (TMKLL) bcgetirqmode;
#pragma aux (TMKLL) bcgetmaxbase;
#pragma aux (TMKLL) bcdefbase;
#pragma aux (TMKLL) bcgetbase;
#pragma aux (TMKLL) bcputw;
#pragma aux (TMKLL) bcgetw;
#pragma aux (TMKLL) bcgetansw;
#pragma aux (TMKLL) bcputblk;
#pragma aux (TMKLL) bcgetblk;
#pragma aux (TMKLL) bcdefbus;
#pragma aux (TMKLL) bcgetbus;
#pragma aux (TMKLL) bcstart;
#pragma aux (TMKLL) bcstartx;
#pragma aux (TMKLL) bcdeflink;
#pragma aux (TMKLL) bcgetlink;
#pragma aux (TMKLL) bcstop;
#pragma aux (TMKLL) bcgetstate;

#pragma aux (TMKLL) rtdefintcmd;
#pragma aux (TMKLL) rtdefinterr;
#pragma aux (TMKLL) rtdefintdata;
#pragma aux (TMKLL) rtreset;
#pragma aux (TMKLL) rtrestore;
#pragma aux (TMKLL) rtdefirqmode;
#pragma aux (TMKLL) rtgetirqmode;
#pragma aux (TMKLL) rtdefmode;
#pragma aux (TMKLL) rtgetmode;
#pragma aux (TMKLL) rtgetmaxpage;
#pragma aux (TMKLL) rtdefpage;
#pragma aux (TMKLL) rtgetpage;
#pragma aux (TMKLL) rtdefpagepc;
#pragma aux (TMKLL) rtdefpagebus;
#pragma aux (TMKLL) rtgetpagepc;
#pragma aux (TMKLL) rtgetpagebus;
#pragma aux (TMKLL) rtdefaddress;
#pragma aux (TMKLL) rtgetaddress;
#pragma aux (TMKLL) rtdefsubaddr;
#pragma aux (TMKLL) rtgetsubaddr;
#pragma aux (TMKLL) rtputw;
#pragma aux (TMKLL) rtgetw;
#pragma aux (TMKLL) rtputblk;
#pragma aux (TMKLL) rtgetblk;
#pragma aux (TMKLL) rtsetanswbits;
#pragma aux (TMKLL) rtclranswbits;
#pragma aux (TMKLL) rtgetanswbits;
#pragma aux (TMKLL) rtgetflags;
#pragma aux (TMKLL) rtputflags;
#pragma aux (TMKLL) rtsetflag;
#pragma aux (TMKLL) rtclrflag;
#pragma aux (TMKLL) rtgetflag;
#pragma aux (TMKLL) rtgetstate;
#pragma aux (TMKLL) rtbusy;
#pragma aux (TMKLL) rtlock;
#pragma aux (TMKLL) rtunlock;
#pragma aux (TMKLL) rtgetcmddata;
#pragma aux (TMKLL) rtputcmddata;

#pragma aux (TMKLL) mtdefintx;
#pragma aux (TMKLL) mtdefintsig;
#pragma aux (TMKLL) mtreset;
#pragma aux (TMKLL) mtgetsw;

#endif
